TRANSFORMATION FKAux
 -- Auxiliary function called by FactorK.  Applies
 -- necessary simplifying rules to compositions, f o g
 USES
  ru1: f o id                             --> f,
  ru2: id o f                             --> f,
  ru3: <K (x), K (y)>                     --> K ([x, y]),
  ru4: f o K (x)	                      --> K (f ! x),
  ru5: UNNEST (f o #2, K (A)) o SINGLETON --> K (iterate (K (true), f) ! A),
  ru6: UNNEST (#2, K (A)) o SINGLETON     --> K (A),

  PullP2SHRF,
  PD1,
  PD2,
  LB
 BEGIN
  {ru1 || ru2 || ru3 || ru4} ||
  {GIVEN UNNEST (_F, g) o SINGLETON DO {PullP2SHRF (g); {ru5 || ru6}}} ||
  {GIVEN ITERATE (_P, _F) o UNNEST (_F, _F) DO PD1} ||
  {GIVEN UNNEST (f, g) o UNNEST (_F, _F) DO {LB (f); PullP2SHRF (g); PD2}}
 END

