#ifndef _MYMULTILINEEDIT_H_
#define _MYMULTILINEEDIT_H_

#include <qwidget.h>
#include <qmultilineedit.h>
#include "DEVertSplit.H"
#include <qpalette.h>
#include <qpainter.h>
#include <qpixmap.h>
#include "LCSub.H"

class DVertSplit;
class MyMainWindow;

class MyMultiLineEdit : public QMultiLineEdit
{
  Q_OBJECT
 public:
  MyMultiLineEdit(DVertSplit * parent = 0, const char * name = 0, MyMainWindow* grandpa = 0, bool notCentral = 0);
  void setNormalPalette();
  void setCurrPalette();
  void setCurr(int,LCSubstring*, int);
  int findKN(int, int);
  void updateBCA(int*,int*,int);
  int getCurrKN();
  bool close(bool);
 protected:
  void mousePressEvent( QMouseEvent * );
  void mouseReleaseEvent( QMouseEvent * );
  void paintCell(QPainter* p, int row, int col);
private:
  void highlightKN(int);
  void markStatement(QColor, QPainter*,int, int, int);
  void getInfo(int, int*, int*, int*, int*);
  //void pixelPosToCursorPos(QPoint,int*,int*);
  
public slots:
  void doBreak();
  void doCondition();
  void doClear();

protected:
  int currSL;
  int currSC;
  int currEL;
  int currEC;
  int currNumStmts;
  DVertSplit * parentWid;
  MyMainWindow * grandpaWid;
  LCSubstring* currLCArray;
  int currArraySize;
  int* currBA;
  int* currCA;
  int currKN;
  int currWorkingKN;
  bool _notCentral;

};

#endif
