//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon-Suk Lee (jl)
//  FILE: PCMulMatchStmt.H
//  PROJ: COKO
//  DATE: 10/9/96                                                              
//
// SYNOPSIS
// Class definitions for CMulMatchStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMULMATCHSTMT_H_
#define _PCMULMATCHSTMT_H_
#define MAXARG 20

#include <stdarg.h>
#include "PCStmt.H"
#include "PCPattern.H"
#include "PCEqn.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CMulMatchStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. 
//  MulMatchStmt is consist of one or more equations.
//
//////////////////////////////////////////////////////////////////////////////

class CMulMatchStmt : public CStmt {
protected:
  CEqn* _eqnList[MAXARG];    
  // equation list

  CStmt *_stmt;
  // Match statement body

private:
  int _count;

public:
  CMulMatchStmt(CStmt* ... );                       
  // Constructor
  
  ~CMulMatchStmt();                      
  // Destructor
  
  CState *Exec(CState *);
  // What to do when executed

};

#endif
