/*
 * Copyright 1995, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/*
//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl@cs.brown.edu)
//  FILE: PParser.h
//
//  PROJ: COKO Compiler
//  DATE: 8/97                                                          
//
//////////////////////////////////////////////////////////////////////////////
*/
/* -*-Mode:c++-*- */

#ifndef _PPARSER_H_
#define _PPARSER_H_

#include <fstream.h>
//#include <libc.h>
#include "mstring.h"
#include <list.h>
#include <set.h>

typedef struct {string code; string name; } PCode;
typedef set<string, less<string> > PAIdentSet;

class PPropertyBlock 
{
 protected:
  string _name;
  PCode* _bodyCode;
  PAIdentSet _includes;

 public:
  PPropertyBlock(string name, PAIdentSet includes, PCode *body);
  const char *Name(void);
  void Emit(ofstream & foutH, ofstream & foutC);
};

#endif
