//////////////////////////////////////////////////////////////////
//
//  NAME: Joon S. Lee (jl)
//  
//  FILE: PCPreCondRule.H
//  PROJ: COKO
//  DATE: 6/96
// 
//  SYNOPSIS
//  This class is for PreCondRule Declaration/Invoke statements.
//
/////////////////////////////////////////////////////////////////

#ifndef _PCPRECONDRULE_H_
#define _PCPRECONDRULE_H_

#include <PCState.H>
#include "KONameUnion.H"
#include "KGlobals.H"
#include "PCPattern.H"
#include "KONonType.H"
#include "PCRule.H"
#include "PCPreCond.H"


class CPreCondRule : public CRule
{
public:
  CPreCondRule (CPreCond*, CPattern*, CPattern*);
  //  Constructor for rule representation. 
  //  Takes two arguments that are patterns of
  //  lhs and rhs, respectively. 
  
  ~CPreCondRule();
  // Destructor
  
  CState *Exec(CState*);
  //  Executes the given statement.
  //  Takes the state of the program before the statement
  //  is executed, and then returns the state of the 
  //  program after the statement is executed.
  
protected:
  
  CPreCond* _precond;
  // precondition list
  
};

#endif
