
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTDoubleBang.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTDoubleBang.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TDoubleBang
// Parameters: (TagExp* te1, TagExpList* te2)
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TDoubleBang::TDoubleBang(TagExp* te1, TagExpList* te2):TagExp(TAGEXP_DOUBLEBANG, "!!" )
{
  one = te1;
  two = te2;
  variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TDoubleBang
// Parameters:(TDoubleBang& other)
//
// Copy Constructor
//
// refine later..
/////////////////////////////////////////////////////////////////////////////

TDoubleBang::TDoubleBang(const TDoubleBang& other):TagExp((TagExp &)other)
{
    one = other.One()->Copy();
    two = other.Two()->Copy();
    variableNum = other.getVariableNum();
  // 	two = NULL; 
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TDoubleBang
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TDoubleBang::~TDoubleBang()
{
  delete one;
  delete two;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TDoubleBang::Copy() const
{
  TDoubleBang* temp = new TDoubleBang (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// value-based equality.
//
/////////////////////////////////////////////////////////////////////////////

int TDoubleBang::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// return a union type, NameUnion.
// since NonType has 6 different sub-classes....
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TDoubleBang::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TDoubleBang::nextChild()
{
    if(currChild == 0)
      {
        currChild++;
        return one;
      }
    else { if(currChild == 1){
               currChild++;
               return NULL;
            } 
            else{ 
               return NULL;
            }
         }
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TDoubleBang::representation()
{
    char *pr1 = one->representation();
    char *pr2 = two->representation();

    char *res = new char[strlen(pr1)+strlen(pr2)+strlen("() !! ()")+1];
    sprintf(res, "(%s) !! (%s)", pr1, pr2);
    delete [] pr1;
    delete [] pr2;
    return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
////////////////////////////////////////////////////////////////////////////

NonType* TDoubleBang::transform(CState* s)
{
  return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TDoubleBang::compares(NonType* nt, CState* a)
{
  return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
//////////////////////////////////////////////////////////////////////////

int TDoubleBang::compareSTM(NonType* nt, CState* a)
{
  return T;
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TDoubleBang::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
    setOne(child);
  else if(which_child == 2)
    setTwo(child);
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
//////////////////////////////////////////////////////////////////////////

char* TDoubleBang::prolog()
{
  return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TDoubleBang::sp_prolog()
{
  return NULL;
}
#endif //_PROLOG_

