
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTStar.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTStar.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TStar
// Parameters: (TagExp* te)
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TStar::TStar(TagExp* te):TagExp(TAGEXP_STAR, "STAR" )
{
    one = te;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TStar
// Parameters:(TStar& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TStar::TStar(const TStar& other):TagExp((TagExp &)other)
{
  one = other.One()->Copy();
  variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TStar
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TStar::~TStar()
{
    delete one;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TStar::Copy() const
{
  TStar* temp = new TStar (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing
//
/////////////////////////////////////////////////////////////////////////////

int TStar::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// does nothing
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TStar::Myname()
{
      return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TStar::nextChild()
{
    if(currChild == 0)
      {
        currChild++;
        return one;
      }
    else  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TStar::representation()
{
    char *pr = One()->representation();
    char *res = new char[strlen(pr)+strlen("STAR ()")+1];
    sprintf(res, "STAR (%s)", pr);
    delete [] pr;
    return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TStar::transform(CState* s)
{
  return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TStar::compares(NonType* nt, CState* a)
{
  return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TStar::compareSTM(NonType* nt, CState* a)
{
    return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
//  seems useless, delete it.  
//
///////////////////////////////////////////////////////////////////////////

void TStar::replaceChild(NonType* child, int which_child)
{
    if(which_child == 1)
         setOne(child);
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
//////////////////////////////////////////////////////////////////////////

char* TStar::prolog()
{
    return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TStar::sp_prolog()
{
    return NULL;
}
#endif //_PROLOG_

