
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack(mfc) 
//        Xiaoyu Wang(wangxy) 
//  FILE: KOTagExp.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
// SYNOPSIS
//  The class of containable objects.  (Includes
//  integers, strings, as well as pairs and sets of 
//  Objects).  Also should include user defined 
//  typed objects.  This class and its subclasses
//  construct object that are used in KOLA trees.
//  These should be distinguished from
//  OResults which are used in expression trees.
//  KOLA trees are used for optimization.  Expression
//  trees are used to describe the result of a query denoted 
//  by a KOLA tree.
//  
//////////////////////////////////////////////////////////////////////////////

#include "KOTagExp.H"

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: TagExp
// Parameters: (char* n)
//
// Constructor.
//
//////////////////////////////////////////////////////////////////////////////

TagExp::TagExp(TagExpName tn, char* n)
{
  myname = tn;

  if(n == NULL) namestring = NULL;
  else {
    namestring = new char[strlen(n)+1];
    sprintf(namestring, "%s", n);
  }
  variableNum = 0;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TagExp
//
// Parameters: (const TagExp& other)
//
// Copy constructor.
//
/////////////////////////////////////////////////////////////////////////////

TagExp::TagExp(const TagExp& other)
{
  myname = other.Identity();
  namestring = new char[strlen(other.Name())+1];
  sprintf(namestring, "%s", other.Name());
  variableNum = other.getVariableNum();
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TagExp
// Parameters: ()
//
// Destructor.
//
//////////////////////////////////////////////////////////////////////////////

TagExp::~TagExp()
{ 
  if(namestring) {delete[] namestring; namestring = NULL;}
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: sql
// Parameters: ()
//
// Return SQL representation of result of invoking this on o
//
//////////////////////////////////////////////////////////////////////////////

char* TagExp::sql()
{
  return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: oql
// Parameters: ()
//
// Return oql representation of result of invoking this on o
//
//////////////////////////////////////////////////////////////////////////////

char * TagExp::oql()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: tagexp
// Parameter: ()
//
// Symbolic simplification of this. Eventually, this method will replace
// "tagexp" presently only defined with _OSTORE_ flag set
//
//////////////////////////////////////////////////////////////////////////////

TagExp* TagExp::tagexp()
{
    return Copy();
} 



