/////////////////////////////////////////////////////////////////////////////
//
// Name: Xioayu Wang
// File: XMLQL.y
// Proj: XMLQL -> KOLA translator (ox input file)
// Date: 10/00
//
/////////////////////////////////////////////////////////////////////////////

%token  LT  GT  LTSLASH  SLASHGT  WHERE  CONSTRUCT  ELEMENTAS  CONTENTAS  INN
%token  STRING  VAR  ID  COMMA  EQ  NEQ  LBRACE  RBRACE  STAR  DOT  BAR  PLUS

@attributes {char *str;} VAR  ID  STRING
@attributes {Tag *tag; TagExp *path;  TagExp *trans; TagExp *env;} Tp 
@attributes {TagExp *path; TagExpList *trans; TagExp *env;} TpList
@attributes {Function *trans ;} Q  S  Cons  Elem  ElemList  Exp  InList  In       
@attributes {Predicate *trans;} Where Cond

%start S

%{
#include "KGlobals.H"
#include "KOFShiftL.H"
#include "KOFShiftR.H"
#include "KOBAnd.H"
#include "KOBEqu.H"
#include "KOBGE.H"
#include "KOBGT.H"
#include "KOBInvoke.H"
#include "KOBLE.H"
#include "KOBLT.H"
#include "KOBName.H"
#include "KOBNot.H"
#include "KOBOr.H"
#include "KOBPrimitive.H"
#include "KOBVar.H"
#include "KOBool.H"
#include "KOF1.H"
#include "KOF2.H"
#include "KOFAbs.H"
#include "KOFAdd.H"
#include "KOFAvg.H"
#include "KOFCElt.H"
#include "KOFChoose.H"
#include "KOFCompose.H"
#include "KOFCon.H"
#include "KOFConst.H"
#include "KOFCount.H"
#include "KOFDif.H"
#include "KOFDiv.H"
#include "KOFFlatten.H"
#include "KOFFold.H"
#include "KOFID.H"
#include "KOFTID.H"
#include "KOFIns.H"
#include "KOFInt.H"
#include "KOFInverse.H"
#include "KOFIter.H"
#include "KOFIterate.H"
#include "KOFJoin.H"
#include "KOFLSJoin.H"
#include "KOFMax.H"
#include "KOFMin.H"
#include "KOFMinus.H"
#include "KOFMod.H"
#include "KOFMult.H"
#include "KOFNJoin.H"
#include "KOFPCon.H"
#include "KOFPFold.H"
#include "KOFPlus.H"
#include "KOFRSJoin.H"
#include "KOFSet.H"
#include "KOFSingleton.H"
#include "KOFSort.H"
#include "KOFSum.H"
#include "KOFTimes.H"
#include "KOFUni.H"
#include "KOFUnnest.H"
#include "KOFUser.H"
#include "KOFVar.H"
#include "KOFunction.H"
#include "KONameUnion.H"
#include "KONonType.H"
#include "KOOAny.H"
#include "KOODif.H"
#include "KOODiv.H"
#include "KOOFloat.H"
#include "KOOId.H"
#include "KOOIf.H"
#include "KOOInt.H"
#include "KOOInter.H"
#include "KOOInvoke.H"
#include "KOOLink.H"
#include "KOOMinus.H"
#include "KOOMult.H"
#include "KOOName.H"
#include "KOOPair.H"
#include "KOOPlus.H"
#include "KOOSet.H"
#include "KOOStr.H"
#include "KOOTimes.H"
#include "KOOUni.H"
#include "KOOVar.H"
#include "KOObjList.H"
#include "KOObject.H"
#include "KOPCEX.H"
#include "KOPCElt.H"
#include "KOPCFA.H"
#include "KOPCombine.H"
#include "KOPConjunct.H"
#include "KOPConst.H"
#include "KOPDisjunct.H"
#include "KOPEqual.H"
#include "KOPExists.H"
#include "KOPForall.H"
#include "KOPGreater.H"
#include "KOPGreaterEqual.H"
#include "KOPInv.H"
#include "KOPIsnotnull.H"
#include "KOPIsnull.H"
#include "KOPLess.H"
#include "KOPLessEqual.H"
#include "KOPLex.H"
#include "KOPNegate.H"
#include "KOPNotEqual.H"
#include "KOPTimes.H"
#include "KOPUser.H"
#include "KOPVar.H"
#include "KOPredicate.H"
#include "KOTWrap.H"

#include "KOTag.H"
#include "KOTagExp.H"
#include "KOTagExpList.H"
#include "KOTTilde.H"

#include "TYTAny.H"
#include "TYTBag.H"
#include "TYTBool.H"
#include "TYTChar.H"
#include "TYTDC.H"
#include "TYTError.H"
#include "TYTFlt.H"
#include "TYTFunc.H"
#include "TYTInt.H"
#include "TYTObj.H"
#include "TYTPair.H"
#include "TYTPred.H"
#include "TYTSet.H"
#include "TYTStr.H"
#include "TYTTup.H"
#include "TYTUnk.H"
#include "TYTUser.H"
#include "TYTVar.H"
#include "TYType.H"

#include "ENEnvironment.H"
#include "ENEnvEntry.H"


#include <stdio.h>
#include <string.h>
#include <iostream.h>

#include "QLAuxCode.H"

  extern int lineno3;
  extern int QLlex();
  extern char *QLtext;
  
  int QLerror (char *);
  extern NonType *result;

%}

%%

S       :	Q
        @{	@i  result = @S.trans@ = @Q.trans@;
	@}
	|	S  Q
	@{	@i  result = @S.0.trans@ = @Q.trans@;
	@}
 		 
Q	:	WHERE  InList  Where  CONSTRUCT  Cons
	@{	@i  @Q.trans@ = QFunc (@InList.trans@, @Where.trans@, @Cons.trans@);
	@}

	|	WHERE  InList  CONSTRUCT  Cons
	@{	@i   @Q.trans@ = QFunc(@InList.trans@, @Cons.trans@ );	
	@}

InList	:	In
        @{	@i  @InList.trans@ = InListTransFunc( @In.trans@ ); 
	@}
	|	In  InList
	@{	@i  @InList.trans@ = InListTransFunc( @In.trans@, @InList.1.trans@);
	@}

In	:	Tp  INN  STRING
	@{	@i	@In.trans@ = InTransFunc("STRING", @Tp.env@, @Tp.trans@, @STRING.str@); 
		@i	@Tp.path@ = TpPathTagExp(); 
	@}
	/*	In : Tp  IN  "(filename)"  */

	|	Tp  INN  VAR
	@{	@i	@In.trans@ = InTransFunc("VAR", @Tp.env@, @Tp.trans@, @VAR.str@);
		@i	@Tp.path@ = TpPathTagExp();
	@}
	/*	In : Tp  IN  $ID	   */

Tp	:	LT  ID  GT  LTSLASH  GT
	@{	@i	@Tp.tag@ = TpTag(@ID.str@);
		@i	@Tp.trans@ = TpTransTagExp(@ID.str@);
		@i	@Tp.env@ = TpTEnvTagExp();; 	
	@}
	/*	<ID></>	 */

	|	LT  ID  GT  LTSLASH  ID  GT
        @{	@i	@Tp.tag@ = TpTag(@ID.str@); 
	 	@i      @Tp.trans@ = TpTransTagExp(@ID.str@);
                @i      @Tp.env@ = TpTEnvTagExp();
        @}
        /*      <ID></ID>  */


	|	LT  ID  GT  VAR  LTSLASH  GT
	@{	@i      @Tp.tag@ = TpTag(@ID.str@);
		@i 	@Tp.trans@ = TpTransTagExp(@ID.str@);
		@i	@Tp.env@ = TpEnvTagExp(@Tp.path@, @ID.str@, @VAR.str@);
	@}
	/* 	<ID> VAR </>	*/

	|	LT  ID  GT  VAR  LTSLASH  ID  GT
      	@{      @i      @Tp.tag@ = TpTag(@ID.str@);
		@i      @Tp.trans@ = TpTransTagExp(@ID.str@);
                @i      @Tp.env@ = TpEnvTagExp(@Tp.path@, @ID.str@, @VAR.str@);
        @}
	/*	<ID> VAR </ID>	*/
	
	|	LT  ID  GT  STRING  LTSLASH  GT
	@{	@i	@Tp.tag@ = TpTag(@ID.str@);
		@i	@Tp.trans@ = TpTransTagExp(@ID.str@, @STRING.str@);
		@i	@Tp.env@ = TpFEnvTagExp();
	@}
	/*	<ID> STRING </>	*/

	|	LT  ID  GT  STRING  LTSLASH  ID  GT
	@{	@i	@Tp.tag@ = TpTag(@ID.str@);
		@i      @Tp.trans@ = TpTransTagExp(@ID.str@, @STRING.str@);
                @i      @Tp.env@ = TpFEnvTagExp();
        @}
	/*	<ID> STRING </ID> 	*/
	
	|	Tp  ELEMENTAS  VAR
	@{	@i	@Tp.1.path@ = CopyTagExp (@Tp.0.path@);
		@i	@Tp.0.tag@ = CopyTag (@Tp.1.tag@);
		@i	@Tp.0.trans@ = TpTransTagExp(@Tp.1.trans@);
		@i	@Tp.0.env@ =  TpEnvTagExp (0,  @Tp.1.env@, @Tp.0.path@, @Tp.1.tag@, @VAR.str@); 
	@}
	/*	Tp  ELEMENT_AS  VAR	0 --- ELEMENT_AS */

	|	Tp  CONTENTAS  VAR
	@{	@i	@Tp.1.path@ = CopyTagExp (@Tp.0.path@);
		@i	@Tp.0.tag@ = CopyTag (@Tp.1.tag@);
		@i	@Tp.0.trans@ = TpTransTagExp ( @Tp.1.trans@ );
		@i	@Tp.0.env@ = TpEnvTagExp (1,  @Tp.1.env@, @Tp.0.path@, @Tp.1.tag@, @VAR.str@); 
	@}
	/*	Tp  CONTENT_AS  VAR	1 --- CONTENT_AS */
	
	|	LT  ID  GT  TpList  LTSLASH  GT
	@{	@i	@TpList.path@ = TpListPathTagExp(@ID.str@, @Tp.0.path@);
		@i	@Tp.tag@ = TpTag(@ID.str@);
		@i	@Tp.env@ = CopyTagExp (@TpList.env@);
		@i	@Tp.trans@ =TpTransTagExp ( @ID.str@,  @TpList.trans@ );
	@}
	/*	<ID> Tp1 Tp2 ... Tpn </>	*/
	
	|       LT  ID  GT  TpList  LTSLASH  ID  GT
        @{      @i      @TpList.path@ = TpListPathTagExp(@ID.str@, @Tp.0.path@);
		@i	@Tp.tag@ = TpTag(@ID.str@);
                @i      @Tp.env@ = CopyTagExp (@TpList.env@);
                @i      @Tp.trans@ =TpTransTagExp( @ID.str@,  @TpList.trans@ );
        @}
	/*	<ID> Tp1 Tp2 ... Tpn </ID>	*/

TpList	:	Tp  
	@{	@i	@Tp.path@ =CopyTagExp (@TpList.path@);
		@i	@TpList.trans@ = TpListTransTagExpList(@Tp.trans@);; 
		@i	@TpList.env@ = CopyTagExp (@Tp.env@); 
	@} 

	|	 Tp  TpList
	@{	@i	@Tp.path@ = CopyTagExp (@TpList.0.path@);
		@i	@TpList.1.path@ = CopyTagExp (@Tp.0.path@);
		@i	@TpList.0.trans@ = TpListTransTagExpList (@Tp.trans@, @TpList.1.trans@); 
		@i	@TpList.0.env@ = TpListEnvTagExp ( @Tp.env@, @TpList.1.env@ );
	@}


Cons	:	Elem	
	@{	@i	@Cons.trans@ = ConsTransFunc( @Elem.trans@ );
	@}
	
Elem	:	VAR	
	@{	@i	@Elem.trans@ = ElemTransFunc( @VAR.str@ );	
	@}

	|	LT  ID  GT  ID  LTSLASH  GT
	@{	@i	@Elem.trans@ = ElemTransFunc( 1, @ID.0.str@, @ID.1.str@ );	
	@}
	/*	<ID> ID1 </> 	*/

        |       LT  ID  GT  ID  LTSLASH  ID  GT
        @{      @i      @Elem.trans@ = ElemTransFunc( 1, @ID.0.str@, @ID.1.str@ );
        @}
        /*      <ID> ID1 </ID>    */      

	|	LT  ID  GT  ElemList LTSLASH  GT
	@{	@i	@Elem.trans@ = ElemTransFunc(@ID.str@, @ElemList.0.trans@);
	@}	
	/*	<ID> Elem1 Elem2 ... Elemn </>	*/
	
	|	LT  ID  GT  ElemList LTSLASH  ID  GT
        @{      @i      @Elem.trans@ = ElemTransFunc(@ID.str@, @ElemList.0.trans@);
        @}     
	/*	<ID> Elem1 Elem2 ... Elemn  </ID>  */
             
	|	LBRACE  Q  RBRACE
	@{	@i	@Elem.trans@ = CopyFunc ( @Q.trans@ );
	@}
	/*	{ Q }   */ 

ElemList:	Elem  
	@{	@i	@ElemList.trans@ = CopyFunc ( @Elem.trans@ );
	@}
	|	Elem  ElemList
	@{	@i	@ElemList.0.trans@ = ElemListTransFunc( @Elem.trans@, @ElemList.1.trans@ );
	@}

Where	:	Cond
	@{	@i	@Where.trans@ =  CopyPred ( @Cond.trans@ );	
	@}
	|	Cond  COMMA  Where  	
	@{	@i	@Where.0.trans@ = WhereTransPred ( @Cond.trans@, @Where.1.trans@ );	
	@}	

Cond	:	Exp  EQ  Exp
	@{	@i	@Cond.trans@ = CondTransPred("EQ", @Exp.0.trans@, @Exp.1.trans@);
	@}
	|	Exp NEQ  Exp
	@{	@i	@Cond.trans@ = CondTransPred("NEQ", @Exp.0.trans@, @Exp.1.trans@);
	@}

Exp	:	VAR
	@{	@i	@Exp.trans@ = ExpTransFunc("VAR", @VAR.str@);
	@}

	|	STRING	
	@{	@i	@Exp.trans@ = ExpTransFunc("STRING", @STRING.str@);
	@}
 
%%

int QLerror(char *s){
  cerr<< s << "found at line: "<< lineno3 <<" ("<<QLtext <<")"<<"\n\n";
  return 0;
}






